map={
	FANE_LEVEL: 9,
	totalLevels: 14,
	numBranches: 4,
	init:function(){
		map.levels = [];
		map.levelIndex = 0;

		var branchIndices = [10,11,12,13];
		branchIndices = game.shuffle(branchIndices);

		map.GARDEN_LEVEL = branchIndices[0];
		map.LIBRARY_LEVEL = branchIndices[1];
		map.MAUSOLEUM_LEVEL = branchIndices[2];
		map.PHARMACOPOEIA_LEVEL = branchIndices[3];

		map.branchNames = [];
		map.branchNames[map.GARDEN_LEVEL] = 'Greenhouse';
		map.branchNames[map.LIBRARY_LEVEL] = 'Library';
		map.branchNames[map.MAUSOLEUM_LEVEL] = 'Mausoleum';
		map.branchNames[map.PHARMACOPOEIA_LEVEL] = 'Pharmacopoeia';

		map.branchDescriptions = [];
		map.branchDescriptions[map.GARDEN_LEVEL]="The Greenhouse is a quiet corner of the hotel, being filled mainly with plants and snakes.<br><br>But a legendary beast called the Varcolac also lives there. At night the Varcolac turns into a ferocious wolf with uncanny senses and strength."; 
		map.branchDescriptions[map.LIBRARY_LEVEL] = 'With abundant lighting and books, the Library is a favorite location for humans residing in the hotel.<br><br>A human Princess, kidnapped years ago by Fane, takes refuge there as well. Having nothing to do but read, she has developed extensive skills in both white and black magic.';
		map.branchDescriptions[map.MAUSOLEUM_LEVEL] = 'The recent wars have filled the Mausoleum to the brim. It is home to innumerable dead and undead.<br><br>A vampire necromancer called the Strigoi roams the narrow passageways there looking for fresh corpses to add to his undead army.';
		map.branchDescriptions[map.PHARMACOPOEIA_LEVEL] = 'The Pharmacopoeia was once a treasure trove of food, medicine, and magical elixirs. Now it is filled with all sorts of desperate souls fighting over the scraps.<br><br>A mischievous faery in the Pharmacopoeia called the Sprididus plays tricks on the minds of any who enter.';
		/*
		map.generationOptions = {
			levelSize: 40,
			steps: 4,					//6 or more generally produces open rooms
			hallwayLengthMin: 25,
			hallwayLengthMax: 45,
			roomSizeMin: 3,
			roomSizeMax: 6,
			branchChance: .1,
			torchChance: .06,
			monsterChance: .05,
			doorChance: .5,
			itemChance: .305,
			itemChances:[
				[Sword,		0.1],
				[Shield,	0.1],
				[Armor,		0.1],
				[Gold,		0.1],
				[Book,		0.2],
				[Potion,	0.5],
				[Essence,	0.0]
			]
		};
		*/
	},
	pickLevel:function(level){
		//2 levels above (out of depth)	5
		//next level (out of depth)	15
		//this level	30
		//prev level	15
		//random level below that	35
		
		if(level>8){
			//mainly for mausoleum
			level = 6;
		}

		var r= Math.random();
		if(r<.02){
			return Math.min(8,level+2);
		}else if(r<.2){
			return Math.min(8,level+1);
		}else if(r<.5){
			return Math.min(8,level);
		}else if(r<.7){
			return Math.max(0,Math.min(8,level-1));
		}else{
			return map.randRange(0,Math.min(8,level));
		}
	},
	pickMonster:function(level){
		var mLevel = map.pickLevel(level);
	
		//branches
		if(level > map.FANE_LEVEL){
			mLevel = level;
		}

		var monsters= [
			[Grunt],
			[Mercenary,Bat,Grunt],
			[RatSoldier, Runner,Mercenary,FieldViper],
			[Marauder,LapisGolem,Runner],
			[Brawler,GreenMan,Marauder],
			[Hunter,Brawler,RatAssassin],
			[Hunter,Brawler,Marauder,Runner,Moroi],
			[Solomonar,Noble,SandViper],
			[EmeraldGolem, SunstoneGolem, IceGolem, Balaur,Solomonar,Noble,Solomonar,Noble],
			[]
		];

		monsters[map.GARDEN_LEVEL] = [GreenMan, GreenMan, FieldViper, SandViper];
		monsters[map.LIBRARY_LEVEL] = [Mercenary, Marauder, Solomonar, Mercenary, Marauder, Solomonar, Noble, LapisGolem, SunstoneGolem, IceGolem, EmeraldGolem];
		monsters[map.MAUSOLEUM_LEVEL] = [Grunt, Runner, Noble, Hunter, Brawler, Bat, RatSoldier, RatAssassin, Moroi];
		monsters[map.PHARMACOPOEIA_LEVEL] = [Grunt, FieldViper, SandViper, Mercenary, Bat, RatSoldier, Hunter, Brawler,Runner, Marauder, GreenMan, LapisGolem, RatAssassin, Noble, Solomonar, Moroi, SunstoneGolem, IceGolem, EmeraldGolem, Balaur];
		var levelMonsters = monsters[mLevel];
		
		return levelMonsters[0,map.randRange(0,levelMonsters.length-1)];
	},
	getCurrentLevel:function(){
		return map.levels[map.levelIndex];
	},
	getDisplayTiles:function(){
		var displayTiles = [];
		for(var i=player.x-playerOffset;i<=player.x+playerOffset;i++){
			for(var j=player.y-playerOffset;j<=player.y+playerOffset;j++){
				displayTiles.push(map.getTile(i,j));
			}
		}
		return displayTiles;
	},
	findTile:function(source,tile){
		for(var i=0;i<source.length;i++){
			if(tile.equals(source[i])){
				return true;
			}
		}
		return false;
	},
	getMonsterDisplayTiles:function(x,y, monster){
		var displayTiles = [];
		if(monster.type == "varcolac" && monster.upgraded){
			for(var i=1;i<=monster.tile.level.levelSize-2;i++){
				for(var j=1;j<=monster.tile.level.levelSize-2;j++){
					displayTiles.push(map.getTile(i,j));
				}
			}
		}else{
			for(var i=x-playerOffset;i<=x+playerOffset;i++){
				for(var j=y-playerOffset;j<=y+playerOffset;j++){
					displayTiles.push(map.getTile(i,j));
				}
			}
		}
		
		return displayTiles;
	},
	//returns LIT torches
	getTorches:function(){
		var litTorches = [];
		var torches = map.getCurrentLevel().torches;
		for(var i=0;i<torches.length;i++){
			if(torches[i].tile.torch==2){
				litTorches.push(torches[i]);
			}
		}
		return litTorches;
	},
	getTile:function(i,j){
		var level = map.getCurrentLevel();
		return level.getTile(i,j);
	},
	draw:function(){
		for(var i=0;i<canvasTiles;i++){
			for(var j=0;j<canvasTiles;j++){
				var drawX = player.x-playerOffset+i;
				var drawY = player.y-playerOffset+j;
			
				var tile=map.getTile(drawX,drawY);

				tile.draw(i,j);
				
				if(tile.monster!=null){
					//tile.monster.draw(i,j);
				}
			}
		}
	},
	drawBlack: function(i,j){
		//ctx.fillStyle = "rgb(11,9,17)";
		//ctx.fillRect(i*tileSize,j*tileSize,tileSize,tileSize);
	},
	drawSunlight:function(){
		level = map.getCurrentLevel;
		for(var i=0;i<canvasTiles;i++){
			for(var j=0;j<canvasTiles;j++){
				var drawX = player.x-playerOffset+i;
				var drawY = player.y-playerOffset+j;
			
				var tile=map.getTile(drawX,drawY);

				if(tile.light>=1 && tile.playerVisible){
					ctx.fillStyle = "rgba(255,255,180,"+Math.min(.90,player.lightingMultiplier*tile.light/40)+")";
					ctx.fillRect(i*tileSize,j*tileSize,tileSize,tileSize);
				}
			}
		}
	},
	drawMap:function(){
		mapCtx.clearRect(0,0,1000,1000);

		var tileBuffer = 1;

		var actualTile = Math.floor(mapTileSize * (40/map.getCurrentLevel().levelSize));
		
		for(var i=-tileBuffer;i<map.getCurrentLevel().levelSize+tileBuffer;i++){
			for(var j=-10;j<map.getCurrentLevel().levelSize+tileBuffer;j++){
				var tile=map.getTile(i,j);
				if(//true
					//true || 
					tile.explored){
					if(tile.type=="staircase"){
						if(tile.branch){
							mapCtx.fillStyle = "orange";
						}else if(tile.direction == "up"){
							mapCtx.fillStyle = "purple";
						}else{
							mapCtx.fillStyle = "blue";
						}
					}else if(tile.type=="door"){
						mapCtx.fillStyle = "white";
					}else if(tile.wallType=="stained" || tile.wallType == "glass"){
						if(tile.light>=20){
							mapCtx.fillStyle = "yellow";
						}else{
							mapCtx.fillStyle = "cyan";
						}
					}else if(tile.isPassable()){
						//mapCtx.fillStyle = "rgba(175,175,175,1)";
						if(tile.light>=20){
							mapCtx.fillStyle = "yellow";
						}else{
							mapCtx.fillStyle = 'hsl(0,0%,'+
								Math.min(70,tile.light*.666+.15)*100
							+'%)';
						}
					}else{
						mapCtx.fillStyle = "rgba(75,75,130,1)";
					}

					if(tile.item != null && tile.item.name != "Chronicle"){
						mapCtx.fillStyle = "lime";
					}

					/*if(tile.torch==2){
						mapCtx.fillStyle = "yellow";
					}*/

					

					mapCtx.fillRect((i+tileBuffer)*actualTile,(j+tileBuffer)*actualTile,actualTile,actualTile);

					if(tile.torch==1){
						mapCtx.fillStyle = "#7A5000";
						mapCtx.fillRect((i+tileBuffer)*actualTile,(j+tileBuffer)*actualTile,Math.ceil(actualTile/2),Math.ceil(actualTile/2));
					}

					if(player.detect > 0 && tile.monster != null && tile.monster.type != "obstacle"){
						mapCtx.fillStyle = "red";
						mapCtx.fillRect((i+tileBuffer)*actualTile,(j+tileBuffer)*actualTile,actualTile,actualTile);
					}
				}
				
			}
		}

		mapCtx.fillStyle = "rgba(255,0,0,1)";
		mapCtx.fillRect((player.x+tileBuffer)*actualTile-3,(player.y+tileBuffer)*actualTile-3,actualTile+6,actualTile+6);		
		mapCtx.fillStyle = "rgba(255,255,255,1)";
		mapCtx.fillRect((player.x+tileBuffer)*actualTile,(player.y+tileBuffer)*actualTile,actualTile,actualTile);
	},
	generateAllLevels:function(){
		map.levels = [];
	
		for(var i=0;i<map.totalLevels;i++){
			var level = map.generateLevel(i);
			map.levels.push(level);
			level.generateMonsters();
			level.generateItems();
		}
	},
	generateLevel:function(levelNum){
		if(levelNum==map.FANE_LEVEL){
			map.generationOptions = {
				levelSize: 10,
				steps: 2,					//6 or more generally produces open rooms
				minSize: 0,
				maxSize: 100000,
				hallwayLengthMin: 25,
				hallwayLengthMax: 45,
				roomSizeMin: 3,
				roomSizeMax: 6,
				branchChance: .1,
				torchChance: .05,
				monsterChance: 0,
				doorChance: 0,
				obstacles: [],
				obstacleChance: 0,
				minItems: 10,
				maxItems: 10,
				mantrapChance: 0,
				itemChances:[
					[Gold,1]
				]
			};
		}else if(levelNum==map.GARDEN_LEVEL){
			map.generationOptions = {
				levelSize: 30,
				steps: 4,					//6 or more generally produces open rooms
				minSize: 800,
				maxSize: 800,
				hallwayLengthMin: 10,
				hallwayLengthMax: 12,
				roomSizeMin: 3,
				roomSizeMax: 6,
				branchChance: .1,
				torchChance: .025,
				monsterChance: .015,
				doorChance: .5,
				minItems: 4,
				maxItems: 6,
				obstacles: [Plant,Plant,Plant, Plant,Plant,Statue],
				obstacleChance: .66,
				appropriateObstacle: function(i,j){
					var c = 15;
					var id = Math.abs(c-i);
					var jd = Math.abs(c-j);
					if(	(i%2==0 && j>=(c-id) && j<=(c+id))
					||	(j%2==0 && i>=(c-jd) && i<=(c+jd))){
						return true;
					}
					return false;
				},
				stainedGlassChance: 1,
				woodenWallChance: 1,
				mantrapChance: .2,
				glass: true,
				outerHallway: true,
				itemChances:[
					[Gold,.8],
					[Potion,.2]
				]
			};
		}else if(levelNum==map.LIBRARY_LEVEL){
			map.generationOptions = {
				levelSize: 50,
				steps: 4,					//6 or more generally produces open rooms
				minSize: 1400,
				maxSize: 1400,
				hallwayLengthMin: 10,
				hallwayLengthMax: 12,
				roomSizeMin: 4,
				roomSizeMax: 8,
				branchChance: .1,
				torchChance: .1,
				monsterChance: .025,
				doorChance: 1,
				minItems: 9,
				maxItems: 11,
				obstacles: [Table],
				obstacleChance: .97,
				appropriateObstacle: function(i,j){
					if(Math.floor(i/2) % 3 == 1 && Math.floor(j/3) % 3 ==1){
						return true;
					}
					return false;
				},
				stainedGlassChance: 0,
				woodenWallChance: 1,
				itemChances:[
					[Book,1]
				]
			};
		}else if(levelNum==map.MAUSOLEUM_LEVEL){
			map.generationOptions = {
				levelSize: 45,
				steps: 4,					//6 or more generally produces open rooms
				minSize: 650,
				maxSize: 650,
				hallwayLengthMin: 20,
				hallwayLengthMax: 30,
				roomSizeMin: 2,
				roomSizeMax: 4,
				branchChance: .2,
				torchChance: .004,
				monsterChance: .025,
				doorChance: 0,
				minItems: 7,
				maxItems: 10,
				obstacles: [Tomb],
				obstacleChance: .4,
				appropriateObstacle: function(i,j){
					var halfSize = map.generationOptions.levelSize/2.0;
					if(Math.random()<Math.max(
						Math.abs(halfSize-i),
						Math.abs(halfSize-j)
					)/halfSize){
						return true;
					}else{
						return false;
					}
				},
				stainedGlassChance: 0,
				woodenWallChance: 0,
				itemChances:[
					[Sword,		0.25],
					[Shield,	0.25],
					[Armor,		0.25],
					[Gold,		0.25],
				]
			};
		}else if(levelNum==map.PHARMACOPOEIA_LEVEL){
			map.generationOptions = {
				levelSize: 55,
				steps: 7,					//6 or more generally produces open rooms
				minSize: 800,
				maxSize: 1200,
				hallwayLengthMin: 25,
				hallwayLengthMax: 35,
				roomSizeMin: 8,
				roomSizeMax: 18,
				branchChance: .1,
				torchChance: .025,
				monsterChance: .01,
				doorChance: 0,
				minItems: 7,
				maxItems: 13,
				obstacleChance: 0,
				stainedGlassChance: 0,
				woodenWallChance: .9,
				itemChances:[
					[Potion,1]
				]
			};
		}else{
			var steps = map.randRange(3,5);
			var roomSizeMin = map.randRange(3,5);
			var levelSize = map.randRange(40,40);
			if(levelNum==0){
				levelSize = 40;
			}
		
			if(steps==3){
				var baseTorch = .09;
			}else if(steps==4){
				var baseTorch = .05;
			}else if(steps==5){
				var baseTorch = .02;
			}
		
			
			if(levelNum==map.FANE_LEVEL){
				var woodenWallChance = 0;
			}else if(levelNum>=5){
				var woodenWallChance = .05;
			}else{
				var woodenWallChance = .95;
			}
			
		
			map.generationOptions = {
				levelSize: levelSize,
				steps: steps,					//6 or more generally produces open rooms
				minSize: 500,
				maxSize: 1800,
				hallwayLengthMin: map.randRange(10,25),
				hallwayLengthMax: map.randRange(30,35),
				roomSizeMin: roomSizeMin,
				roomSizeMax: roomSizeMin*2,
				branchChance: .1,
				torchChance: baseTorch+.002*(9-levelNum),
				monsterChance: .0225+0.002*(levelNum),
				obstacles: [Plant, Statue, Table, Bed, Bed],
				obstacleChance: .02,
				appropriateObstacle: function(i,j){
					if(i%2==0 || j%2==0) return true;
					return false;
				},
				//monsterChance: 0,
				doorChance: .5,
				minItems: 8,
				maxItems: 11,
				mantrapChance: 0,
				stainedGlassChance: (9-levelNum)/(9*3),
				woodenWallChance: woodenWallChance,
				itemChances:[
					[Sword,		0.06],
					[Shield,	0.06],
					[Armor,		0.06],
					[Gold,		0.05],
					[Book,		.22],
					[Potion,	0.55]
				]
			};
		}

		/*
			torchChance: .01*(10-4),
			3	.07
			4	.06
			5	.05
			
		*/
		
		
	
		var level = new Level(levelNum);
		level.levelSize = map.generationOptions.levelSize;
		
		for(var i=0;i<map.generationOptions.levelSize;i++){
			level.tiles[i]=[];
			for(var j=0;j<map.generationOptions.levelSize;j++){
				if((j==0 || j==map.generationOptions.levelSize-1 || i==0 || i==map.generationOptions.levelSize-1) && Math.random()<map.generationOptions.stainedGlassChance){
					if(map.generationOptions.glass){
						level.tiles[i][j]=new Glass(i,j,level);
					}else{
						level.tiles[i][j]=new StainedGlass(i,j,level);
						if(Math.random()<.15){
							level.tiles[i][j].penetrated=true;
						}
					}
				}else{
					if(Math.random()<map.generationOptions.woodenWallChance){
						level.tiles[i][j]=new WoodenWall(i,j,level);
					}else{
						level.tiles[i][j]=new StoneWall(i,j,level);
					}
				}
			}
		}
		
		if(levelNum==0){
			startingLocation = [
				38,
				27
			];
		}else{
			startingLocation = [
				map.randRange(2,map.generationOptions.levelSize-3),
				map.randRange(map.generationOptions.levelSize-2,map.generationOptions.levelSize-2)
			];
		}
		map.createRoom(
			level,
			startingLocation[0],
			startingLocation[1]
		);
		
		gx=startingLocation[0];
		gy=startingLocation[1];
		

		map.floorsGenerated = 0;
		if((levelNum < map.FANE_LEVEL && Math.random()>.5) || levelNum == 0 || map.generationOptions.outerHallway){
			var outerHallway = map.randRange(2,4);
			for(var i=1;i<map.generationOptions.levelSize-1;i++){
				for(var j=1;j<map.generationOptions.levelSize-1;j++){
					if(i>map.generationOptions.levelSize-outerHallway-1
					|| j>map.generationOptions.levelSize-outerHallway-1
					|| i<outerHallway+1
					|| j<outerHallway+1){
						if(Math.random() < map.generationOptions.mantrapChance){
							level.setTile(i,j,new Mantrap(i,j,level),false);
						}else{
							level.setTile(i,j,new Floor(i,j,level),false);
						}
						map.floorsGenerated++;
					}
				}
			}
		}

		map.generationStep(level,gx,gy,map.randRange(0,3),map.generationOptions.steps);
		
		var torchesPlaced = 0;
		
		//TORCHES
		for(var i=0;i<map.generationOptions.levelSize;i++){
			for(var j=0;j<map.generationOptions.levelSize;j++){
				var tile = level.getTile(i,j);
				if(tile.type=="floor"){
					if(levelNum==map.FANE_LEVEL && torchesPlaced==0){
						level.torches.push(new Torch(tile,1)); 
						tile.torch = 2
						torchesPlaced++;
					}
				
					if((levelNum!=map.FANE_LEVEL) && Math.random()<map.generationOptions.torchChance){
						level.torches.push(new Torch(tile,1)); 
						tile.torch = 1;
						if(Math.random()>.65){
							tile.torch = 2;
						}

						torchesPlaced++;
					}
				}
			}
		}
		
		level.setTile(gx,gy,new Floor(gx,gy,level),false);
		
		//DOORS
		for(var i=0;i<map.generationOptions.levelSize;i++){
			for(var j=0;j<map.generationOptions.levelSize;j++){
				var tile = level.getTile(i,j);
				if(Math.random()<map.generationOptions.doorChance){
					var neighbors = tile.getAdjacentNeighbors();
					if((neighbors[0].type=="wall" && neighbors[1].type=="wall"
					&& neighbors[2].type=="floor" && neighbors[3].type=="floor"
					&& (neighbors[2].preferDoor || neighbors[3].preferDoor))
						||
					(neighbors[2].type=="wall" && neighbors[3].type=="wall"
					&& neighbors[0].type=="floor" && neighbors[1].type=="floor"
					&& (neighbors[0].preferDoor || neighbors[1].preferDoor))){
						level.setTile(i,j,new Door(i,j,level),false);
					}
				}
			}
		}
		
		
		level.generateStairs();
		
		if(levelNum==map.FANE_LEVEL){
			level.placeMonster(Fane);
		}else if(levelNum==map.PHARMACOPOEIA_LEVEL){
			level.placeMonster(Spiridus);
		}else if(levelNum==map.MAUSOLEUM_LEVEL){
			level.placeMonster(Strigoi);
		}else if(levelNum==map.LIBRARY_LEVEL){
			level.placeMonster(Princess);
		}else if(levelNum == map.GARDEN_LEVEL){
			level.placeMonster(Varcolac);
		}
	
	
		//first level tutorial area
		if(levelNum==0){
			player.x=38;
			player.y=38;
			
			//assume size 40
			for(var i=36;i<40;i++){
				for(var j=27;j<40;j++){
					if((i==37 && j>27) || i== 39 || j== 39 || (j==28 && i>=37)){
						tile = new WoodenWall(i,j,level);
					}else{
						tile = new Floor(i,j,level);
					}
					tile.tutorial=true;
					level.setTile(i,j,tile,true);
				}
			}
			
			var tutorialTiles = [];
			
			
			var brokenGlass = new StainedGlass(39,37,level);
			brokenGlass.penetrated = true;
			tutorialTiles.push(brokenGlass);
			
			brokenGlass = new StainedGlass(39,36,level);
			brokenGlass.penetrated = true;
			tutorialTiles.push(brokenGlass);
			
			brokenGlass = new StainedGlass(39,35,level);
			brokenGlass.penetrated = true;
			tutorialTiles.push(brokenGlass);
			
			tutorialTiles.push(new StainedGlass(39,38,level));
			tutorialTiles.push(new StainedGlass(39,34,level));
			tutorialTiles.push(new StainedGlass(39,33,level));
			tutorialTiles.push(new StainedGlass(39,32,level));
			tutorialTiles.push(new StainedGlass(39,31,level));
			tutorialTiles.push(new StainedGlass(39,30,level));
			tutorialTiles.push(new StainedGlass(39,29,level));
			
			tutorialTiles.push(new Entry(38,39,level));
			
			tutorialTiles.push(new Door(38,28, level));
			
			for(var i=0;i<tutorialTiles.length;i++){
				var t= tutorialTiles[i];
				level.tiles[t.i][t.j]=t;
			}
			
			
			
			var torchTile,monsterTile;
			
			var monsterTile = level.getTile(38,29);
			monsterTile.monster = new Noble(monsterTile, null, 1.15);
			level.monsters.push(monsterTile.monster);

			torchTile = level.getTile(38,29);
			torchTile.torch=2;
			level.torches.push(new Torch(torchTile,1));
			
		}
		
		
		
		return level;
	},
	generationStep:function(level,gx,gy,hallwayDirection, stepsLeft){
		if(stepsLeft<=0 && map.floorsGenerated > map.generationOptions.minSize) return;

		if(map.floorsGenerated >= map.generationOptions.maxSize) return;
	
		var encourageBranching = true;
		
		if(gy<map.generationOptions.levelSize-10
		&& gx<map.generationOptions.levelSize-10
		&& gx>map.generationOptions.levelSize+10){
			encourageBranching = false;
		}
	
		if(!encourageBranching && map.randRange(0,1) < level.getTile(gx,gy).getTimesExplored()) return;
	
		//if(map.getLevelTile(level,gx,gy).isPassable()) return;
	
		var hallwayLength = map.randRange(
			map.generationOptions.hallwayLengthMin,
			map.generationOptions.hallwayLengthMax
		);
		
		for(var j=0;j<hallwayLength;j++){
			newgxy = map.travel(gx,gy,hallwayDirection);
			
			if(newgxy[0]>=1 && newgxy[0]<map.generationOptions.levelSize-1 && newgxy[1]>=1 && newgxy[1]<map.generationOptions.levelSize-1){
				gx=newgxy[0];
				gy=newgxy[1];
				
				//randomly start new generation step
				if(Math.random()<.05){
					map.generationStep(
						level,
						gx,
						gy,
						(hallwayDirection+map.randRange(1,3))%4,
						stepsLeft-1
					);
				}
				
				if(level.getTile(gx,gy).isPassable()){
					level.getTile(gx,gy).generationExplore();
				}else{
					if(level.getTile(gx,gy).type != "floor" &&
					level.getTile(gx,gy).type != "mantrap"){
						map.floorsGenerated++;
					}
					var tile;
					if(Math.random() < map.generationOptions.mantrapChance){
						tile = new Mantrap(gx,gy,level);
					}else{
						tile = new Floor(gx,gy,level);
					}
					level.setTile(gx,gy,tile,false);
					tile.isHallway = true;
				}
			}else{
				hallwayDirection = map.randRange(0,3);
			}
			
			//randomly change direction
			if(Math.random()<map.generationOptions.branchChance/4){
				hallwayDirection = map.randRange(0,3);
			}
		}

		map.createRoom(
			level,
			gx,
			gy
		);
		
		hallwayDirection = (hallwayDirection+map.randRange(1,3))%4;
		
		for(var k=0;k<4;k++){
			if(k==0 ||
			Math.random()<map.generationOptions.branchChance * (encourageBranching?2:1)){
				map.generationStep(
					level,
					gx,
					gy,
					(hallwayDirection+k)%4,
					stepsLeft-1
				);
			}
		}
	},
	createRoom:function(level,i,j){
		var w = map.randRange(map.generationOptions.roomSizeMin,map.generationOptions.roomSizeMax);
		var h = map.randRange(map.generationOptions.roomSizeMin,map.generationOptions.roomSizeMax);
		
		var startI = Math.floor(i-w/2);
		var startJ = Math.floor(j-h/2);
		
		var endI = startI+w;
		var endJ = startJ+h;
		
		/*if(Math.random()<.5){
			tile.preferredMonster = "human";
		}else{
			tile.preferredMonster = "vampire";	
		}*/
		
		for(var x = startI; x < endI; x++){
			for(var y = startJ; y < endJ; y++){
				//circular room check here
				if(level.index != map.PHARMACOPOEIA_LEVEL ||
				Math.pow(Math.pow(x-i,2)+Math.pow(y-j,2), .5) < w/2.0){
					if(level.getTile(x,y).type != "floor" &&
					level.getTile(x,y).type != "mantrap" &&
					level.getTile(x,y).getTimesExplored()==0){
						map.floorsGenerated++;
					

						if(Math.random() < map.generationOptions.mantrapChance){
							var tile = new Mantrap(x,y,level);
						}else{
							var tile = new Floor(x,y,level);
						}

						
						level.setTile(x,y,tile,false);
					
						if(x==startI || x==endI || y==startJ || y == endJ){
							tile.preferDoor = true;
						}
					}
				}
			}
		}
	},
	randRange:function(min,max){
		return Math.floor(Math.random()*(max-min+1))+min;
	},
	travel:function(i,j,direction){
		if(direction == 0) return [i+1,j];
		if(direction == 1) return [i,j-1];
		if(direction == 2) return [i-1,j];
		if(direction == 3) return [i,j+1];
	},
	travelRandomly:function(i,j){
		direction = map.randRange(0,3);
		
		if(direction == 0) return [i+1,j];
		if(direction == 1) return [i,j-1];
		if(direction == 2) return [i-1,j];
		if(direction == 3) return [i,j+1];
	}
}



function Level(index){
	this.index = index;
	
	this.monsters = [];
	this.torches = [];
	this.tiles = []

	if(index==map.GARDEN_LEVEL){
		this.floorSubtype = 3;
	}else if(index==map.LIBRARY_LEVEL){
		this.floorSubtype = 0;
	}else if(index==map.MAUSOLEUM_LEVEL){
		this.floorSubtype = 1;
	}else if(index==map.PHARMACOPOEIA_LEVEL || index==0){
		this.floorSubtype = 2;
	}else{
		this.floorSubtype = map.randRange(0,2);
	}
	
	this.upstairs = [];
	this.downstairs = [];
}

Level.prototype.getTile = function(i,j){
	if(i>=0 && i<this.levelSize && j>=0 && j<this.levelSize){
			return this.tiles[i][j];
		}else{
			return new StoneWall(i,j,this);
		}
}

Level.prototype.setTile = function(i,j,tile, placeOnEdge){
	if((i>=1 && i<this.levelSize-1 && j>=1 && j<this.levelSize-1) || placeOnEdge){
		this.tiles[i][j]=tile;
	}
}

Level.prototype.generateStairs = function(){
	if(this.index > map.FANE_LEVEL){
		var numStairs = 1;
	}else{
		var numStairs = 2;
	}
	var timeout = 3000;
	var tile;

	if(this.index >= map.FANE_LEVEL-map.numBranches && this.index < map.FANE_LEVEL){
		var numDownStairs = numStairs + 1;
	}else{
		var numDownStairs = numStairs;
	}

	var numUpStairs = numStairs;
	
	for(var i=0;i<numUpStairs;i++){
		//up
		if(this.index != map.FANE_LEVEL){
			for(var j=0;j<timeout;j++){
				tile = this.getTile(map.randRange(2,this.levelSize-3),map.randRange(2,Math.min(33,this.levelSize-3)));
				if(tile.type=="floor" && tile.monster==null && tile.item == null){
					staircase = new Staircase(tile.i,tile.j,this,false);
					staircase.direction = "up";
					staircase.stairNumber = this.upstairs.length;
					this.upstairs.push(staircase);

					this.setTile(staircase.i,staircase.j,staircase);

					if(this.index > map.FANE_LEVEL){
						staircase.branch = true;
						//todo: fix this;
						staircase.branchNum = this.index;
					}

					break;
				}
				
				if(j==timeout-1){
					//console.log("STAIR FAIL");
				}
			}
		}
	}

	for(var i=0;i<numDownStairs;i++){
		//down
		if(this.index > 0 && this.index <= map.FANE_LEVEL){
			
			for(var j=0;j<timeout;j++){
				tile = this.getTile(map.randRange(2,this.levelSize-3),map.randRange(2,Math.min(33,this.levelSize-3)));
				if(tile.type=="floor" && tile.monster==null && tile.item == null){
					staircase = new Staircase(tile.i,tile.j,this,false);
					staircase.direction = "down";
					staircase.stairNumber = this.downstairs.length;
					this.downstairs.push(staircase);
					
					//keep a staircase reference on level, but don't put it down
					if(this.index != map.FANE_LEVEL){
						this.setTile(staircase.i,staircase.j,staircase);
					}
					
					if(i==numDownStairs-1 && this.index>=map.FANE_LEVEL-map.numBranches){
						staircase.branch = true;
						//todo: fix this;
						staircase.branchNum = this.index+1+map.numBranches;
					}

					break;
				}
				
				if(j==timeout-1){
					//console.log("STAIR FAIL");
				}
			}
		}
	}
}

Level.prototype.placeMonster = function(monsterObj){
	while(true){
		var i=map.randRange(0,this.levelSize-1);
		var j=map.randRange(0,this.levelSize-1);
		var tile = this.getTile(i,j);
		if(tile.type=="floor" && tile.monster==null && tile.torch ==0 && tile.item==null){
			var monster = new monsterObj(tile);
			tile.monster = monster;
			this.monsters.push(tile.monster);
	
			return;
		}
	}
}

//and do obstacles too
Level.prototype.generateMonsters = function(){
	for(var i=0;i<this.levelSize;i++){
		for(var j=0;j<this.levelSize;j++){
			var tile = this.getTile(i,j);
			if(tile.type=="floor" && !tile.tutorial && tile.torch==0){
				if(Math.random()<map.generationOptions.monsterChance){			
					var monsterType = map.pickMonster(this.index);
					var monster = new monsterType(tile);								
					tile.monster = monster;
					this.monsters.push(tile.monster);
				}else if(Math.random()<map.generationOptions.obstacleChance && !tile.isHallway
				&& map.generationOptions.appropriateObstacle(i,j)){
					var obstacleType = map.generationOptions.obstacles[
						map.randRange(0,map.generationOptions.obstacles.length-1)
					];
					var obstacle = new obstacleType(tile);
					tile.monster = obstacle;
					this.monsters.push(tile.monster);
				}
			}
		}	
	}
}

Level.prototype.generateItems = function(){
	var chanceTotal = 0;
	var numItems = 0;
	var maxItems = map.randRange(
		map.generationOptions.minItems,
		map.generationOptions.maxItems
	);

	for(var i=0;i<map.generationOptions.itemChances.length;i++){
		chanceTotal+=map.generationOptions.itemChances[i][1];
	}

	while(numItems < maxItems){
		var i=map.randRange(0,this.levelSize-1);
		var j=map.randRange(0,this.levelSize-1);
		var tile = this.getTile(i,j);
		if(tile.type=="floor" && tile.torch==0  && !tile.tutorial && tile.monster==null && tile.item == null){
			var chanceSum = 0;
			var r = Math.random()*chanceTotal;
			for(var k=0;k<map.generationOptions.itemChances.length;k++){
				var c = map.generationOptions.itemChances[k];
				
				if(r>=chanceSum && r<chanceSum+c[1]){
					tile.item=new c[0](tile);
					numItems++;
					break;
				}
				chanceSum+=c[1];
			}
		}	
	}
}

Level.prototype.destroyMonster = function(tile){
	for(var i=0;i<this.monsters.length;i++){
		if(this.monsters[i]!==null && tile.equals(this.monsters[i].tile)){
			this.monsters[i].destroyed=true;
			tile.monster = null;
			this.monsters[i]=null;
			
			return;
		}
	}
}

Level.prototype.removeMonster = function(tile){
	for(var i=0;i<this.monsters.length;i++){
		if(this.monsters[i]!==null && tile.equals(this.monsters[i].tile)){
			tile.monster = null;
			this.monsters[i]=null;
			return;
		}
	}
}